## NMVpnServicePlugin NMVpnServicePlugin |

## Functions

GDBusConnection * | nm_vpn_service_plugin_get_connection ()
void | nm_vpn_service_plugin_secrets_required ()
void | nm_vpn_service_plugin_set_login_banner ()
void | nm_vpn_service_plugin_failure ()
void | nm_vpn_service_plugin_set_config ()
void | nm_vpn_service_plugin_set_ip4_config ()
void | nm_vpn_service_plugin_set_ip6_config ()
gboolean | nm_vpn_service_plugin_disconnect ()
void | nm_vpn_service_plugin_shutdown ()
gboolean | nm_vpn_service_plugin_read_vpn_details ()
gboolean | nm_vpn_service_plugin_get_secret_flags ()

## Properties

char * | service-name | Read / Write / Construct Only
NMVpnServiceState | state | Read / Write
gboolean | watch-peer | Read / Write / Construct Only

## Signals

void | config | Run First
void | failure | Run First
void | ip4-config | Run First
void | ip6-config | Run First
void | login-banner | Run First
void | quit | Run First
void | secrets-required | Run First
void | state-changed | Run First

## Types and Values

#define | NM_VPN_SERVICE_PLUGIN_DBUS_SERVICE_NAME
#define | NM_VPN_SERVICE_PLUGIN_DBUS_WATCH_PEER
#define | NM_VPN_SERVICE_PLUGIN_STATE
| NMVpnServicePlugin

## Object Hierarchy

        GObject
        ╰── NMVpnServicePlugin

## Implemented Interfaces

NMVpnServicePlugin implements GInitable.

## Description

## Functions

### nm_vpn_service_plugin_get_connection ()

    GDBusConnection *
    nm_vpn_service_plugin_get_connection (NMVpnServicePlugin *plugin);

### nm_vpn_service_plugin_secrets_required ()

    void
    nm_vpn_service_plugin_secrets_required
                                   (NMVpnServicePlugin *plugin,
                                    const char *message,
                                    const char **hints);

### nm_vpn_service_plugin_set_login_banner ()

    void
    nm_vpn_service_plugin_set_login_banner
                                   (NMVpnServicePlugin *plugin,
                                    const char *banner);

### nm_vpn_service_plugin_failure ()

    void
    nm_vpn_service_plugin_failure (NMVpnServicePlugin *plugin,
                                   NMVpnPluginFailure reason);

### nm_vpn_service_plugin_set_config ()

    void
    nm_vpn_service_plugin_set_config (NMVpnServicePlugin *plugin,
                                      GVariant *config);

### nm_vpn_service_plugin_set_ip4_config ()

    void
    nm_vpn_service_plugin_set_ip4_config (NMVpnServicePlugin *plugin,
                                          GVariant *ip4_config);

### nm_vpn_service_plugin_set_ip6_config ()

    void
    nm_vpn_service_plugin_set_ip6_config (NMVpnServicePlugin *plugin,
                                          GVariant *ip6_config);

### nm_vpn_service_plugin_disconnect ()

    gboolean
    nm_vpn_service_plugin_disconnect (NMVpnServicePlugin *plugin,
                                      GError **err);

### nm_vpn_service_plugin_shutdown ()

    void
    nm_vpn_service_plugin_shutdown (NMVpnServicePlugin *plugin);

### nm_vpn_service_plugin_read_vpn_details ()

    gboolean
    nm_vpn_service_plugin_read_vpn_details
                                   (int fd,
                                    GHashTable **out_data,
                                    GHashTable **out_secrets);

### nm_vpn_service_plugin_get_secret_flags ()

    gboolean
    nm_vpn_service_plugin_get_secret_flags
                                   (GHashTable *data,
                                    const char *secret_name,
                                    NMSettingSecretFlags *out_flags);

## Types and Values

### NM_VPN_SERVICE_PLUGIN_DBUS_SERVICE_NAME

    #define NM_VPN_SERVICE_PLUGIN_DBUS_SERVICE_NAME "service-name"

### NM_VPN_SERVICE_PLUGIN_DBUS_WATCH_PEER

    #define NM_VPN_SERVICE_PLUGIN_DBUS_WATCH_PEER   "watch-peer"

### NM_VPN_SERVICE_PLUGIN_STATE

    #define NM_VPN_SERVICE_PLUGIN_STATE             "state"

### NMVpnServicePlugin

    typedef struct _NMVpnServicePlugin NMVpnServicePlugin;

## Property Details

### The `“service-name”` property

      “service-name”             char *

Owner: NMVpnServicePlugin

Flags: Read / Write / Construct Only

Default value: NULL

### The `“state”` property

      “state”                    NMVpnServiceState

Owner: NMVpnServicePlugin

Flags: Read / Write

Default value: NM_VPN_SERVICE_STATE_INIT

### The `“watch-peer”` property

      “watch-peer”               gboolean

Owner: NMVpnServicePlugin

Flags: Read / Write / Construct Only

Default value: FALSE

## Signal Details

### The `“config”` signal

    void
    user_function (NMVpnServicePlugin *nmvpnserviceplugin,
                   GVariant           *arg1,
                   gpointer            user_data)

Flags: Run First

### The `“failure”` signal

    void
    user_function (NMVpnServicePlugin *nmvpnserviceplugin,
                   guint               arg1,
                   gpointer            user_data)

Flags: Run First

### The `“ip4-config”` signal

    void
    user_function (NMVpnServicePlugin *nmvpnserviceplugin,
                   GVariant           *arg1,
                   gpointer            user_data)

Flags: Run First

### The `“ip6-config”` signal

    void
    user_function (NMVpnServicePlugin *nmvpnserviceplugin,
                   GVariant           *arg1,
                   gpointer            user_data)

Flags: Run First

### The `“login-banner”` signal

    void
    user_function (NMVpnServicePlugin *nmvpnserviceplugin,
                   char               *arg1,
                   gpointer            user_data)

Flags: Run First

### The `“quit”` signal

    void
    user_function (NMVpnServicePlugin *nmvpnserviceplugin,
                   gpointer            user_data)

Flags: Run First

### The `“secrets-required”` signal

    void
    user_function (NMVpnServicePlugin *nmvpnserviceplugin,
                   char               *arg1,
                   GStrv               arg2,
                   gpointer            user_data)

Flags: Run First

### The `“state-changed”` signal

    void
    user_function (NMVpnServicePlugin *nmvpnserviceplugin,
                   guint               arg1,
                   gpointer            user_data)

Flags: Run First